services:
  # general settings
  _defaults:
    autowire: true
    autoconfigure: true
    public: false
    bind:
      TYPO3\CMS\Core\Cache\Frontend\FrontendInterface $fastCache: '@co-stack.api.fastcache'
      array $extConf: '@=service("TYPO3\\CMS\\Core\\Configuration\\ExtensionConfiguration").get("api")'

  CoStack\Api\:
    resource: '../Classes/*'

  co-stack.api.fastcache:
    class: TYPO3\CMS\Core\Cache\Frontend\FrontendInterface
    factory: [ '@TYPO3\CMS\Core\Cache\CacheManager', 'getCache' ]
    arguments: [ 'tx_api_fastcache' ]

  CoStack\Api\Backend\Token\TcaApiScopeItemsProvider:
    public: true

  CoStack\Api\Middleware\Frontend\EarlyApiMiddleware:
    arguments:
      $requestHandler: '@co-stack.api.request.handler'

  CoStack\Api\Middleware\Frontend\FrontendApiMiddleware:
    arguments:
      $requestHandler: '@co-stack.api.request.handler'
